{-+++ Aufgabe1 Abgabe: 26.10.2016, 15:00 +++-}

--Erstes Beispiel: facInv
--Überprufen, ob ein vorgelegtes Argument m aus der Bildmenge von ! ist. Falls ja, liefert die Funktion facInv diejenige eindeutig bestimmte Zahl k als Resultat mit k! = m. Falls nein, liefert die Funktion facInv das Resultat -1

--Hauptfunktion facInv
facInv :: Integer -> Integer
facInv m
 | m <= 1 = -1
 | otherwise = facImg m 1 1

--Hilfsfunktion: Überprüft, ob ein Integer ein Element des Bildes von ! ist und gibt k zurück, wenn m == k!. Falls nicht, wird -1 zurückgegeben
facImg :: Integer -> Integer -> Integer -> Integer
facImg m kfact k
 | m == kfact = k
 | m > kfact = facImg m (kfact*(k+1)) (k+1)
 | otherwise = -1

--Zweites Beispiel: extractDigits
--Eine Zeichemreihe enthält Ziffern und Nichtziffern. extractDigits entfernt alle Nichtziffern und gibt eine Zeichenreihe t zurück, 
--die Reihenfolge der Zeichen bleibt erhalten.
--Hauptfunktion extractDigits fügt Ziffern in der vorkommenden Reihenfolge zu einem String zusammen
extractDigits :: String -> String
extractDigits s
 | s == "" = ""
 | elem (head s) ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9'] = [(head s)] ++ (extractDigits (tail s))
 | otherwise = extractDigits (tail s)

--Drittes Beispiel: convert
--Eine Rechenvorschrift, die angewendet auf eine Zeichenreihe s den von s repräsentierten Wert berechnet und ausgibt. Ist die Ziffernfolge von s leer, so soll die Funktion convert den Wert 0 zurückgeben.
--Hauptfunktion convert, übergibt den reversierten Ziffernstring an addUp
convert :: String -> Integer
convert s 
 | extractDigits s == "" = 0
 | otherwise = addUp (reverse (extractDigits s)) 1

--Hilfsfunktion 1: addUp summiert die Ziffern multipliziert mit der zugehörigen Zehnerpotenz auf
addUp :: String -> Integer -> Integer
addUp s p
 | s == "" = 0
 | otherwise = ((digitToInt (head s))*p) + addUp (tail s) (p*10)

--Hilfsfunktion 2: digitToInt wandelt Char in Integer um
digitToInt :: Char -> Integer
digitToInt c 
 | c == '1' = 1
 | c == '2' = 2
 | c == '3' = 3
 | c == '4' = 4
 | c == '5' = 5
 | c == '6' = 6
 | c == '7' = 7
 | c == '8' = 8
 | c == '9' = 9
 | otherwise = 0

--Viertes Beispiel: findLeftMostPrime
--Angewendet auf eine Zeichenreihe s und eine positive Zahl n, n ≥ 1, liefert die Funktion findLeftMostPrime den Wert der 
--am weitesten links in der Ziffernfolge von s beginnenden Teilzeichenreihe t, die Länge n hat, mit einer von 0 verschiedenen
--Ziffer beginnt und deren Wert eine Primzahl ist. Gibt es keine solche Teilzeichenreihe
--in s oder ist n ≤ 0, so gibt die Funktion findLeftMostPrime den Wert 0 zuruck.
--Hauptfunktion: findLeftMostPrime, übergibt Ziffernstring an extractprime inkl. Stelligkeit der Zahl
findLeftMostPrime :: String -> Int -> Integer
findLeftMostPrime s n
 | ((s == "") || (n <= 0)) = 0
 | n > (length s) = 0
 | otherwise = extractprime (extractDigits s) n 

--Hilfsfunktionen isPrime zur Bestimmung von Primzahlen
isPrime :: Integer -> Bool
isPrime n = null [ x  | x <- [2..n-1], mod n x == 0]

--Hilfsfunktion 3: extractprime untersucht die Zahl aus ersten n Stellen des Strings und gibt diese zurück,
--wenn sie eine Primzahl ist. Bemerkung: es werden nur die ersten 1000 Primzahlen untersucht.
extractprime :: String -> Int -> Integer
extractprime s n 
 | n > (length s) = 0
 | (head s) == '0' = extractprime(drop 1 s) n
 | (isPrime(convert(take n s))) && (convert(take n s) /= 1) = convert(take n s)
 | otherwise = extractprime(drop 1 s) n

--Fünftes Beispiel: findAllPrimes
--eine Variante findAllPrimes der Funktion findLeftMostPrime, die
--nicht nur das linkeste Vorkommen einer Teilzeichenreihe bestimmter L¨ange mit Primzahlwert
--ermittelt, sondern alle dieser (sich m¨oglicherweise) uberlappenden Teilzeichenreihen.
--Schreiben Sie also eine Haskell-Rechenvorschrift findAllPrimes mit der Signatur
--findAllPrimes :: String -> Int -> [Integer]
--die angewendet auf eine Zeichenreihe s und eine positive Zahl n, n ≥ 1, die Werte aller
--in der Ziffernfolge von s (m¨oglicherweise uberlappend) vorkommender Teilzeichen- ¨
--reihe t bestimmt, die L¨ange n haben, mit einer von 0 verschiedenen Ziffer beginnen
--und deren Wert eine Primzahl ist. Gibt es keine solchen Teilzeichenreihen in s oder
--ist n ≤ 0, so gibt die Funktion findAllPrimes die leere Liste zuruck.
--Hauptfunktion: findAllPrimes, überprüft Parameter und übergibt den Ziffernstring an extractAllPrimes inkl. Stelligkeit der Zahl
findAllPrimes :: String -> Int -> [Integer]
findAllPrimes s n
 | ((s == "") || (n <= 0) || (n > (length s))) = []
 | otherwise = extractAllPrimes (extractDigits s) n

--Hilfsfunktion: extractAllPrimes erstellt eine Liste aller (sich überlappenden) Primzahlen in dem übergebenen Ziffernstring
extractAllPrimes :: String -> Int -> [Integer]
extractAllPrimes s n
 | n > (length s) = []
 | (head s) == '0' = extractAllPrimes(drop 1 s) n
 | (isPrime (convert(take n s))) && (convert(take n s) /= 1) = [convert(take n s)] ++ extractAllPrimes(drop 1 s) n
 | otherwise = extractAllPrimes(drop 1 s) n