{- Aufgabe 7 Version 3 -}
--Notwendige Definitionen

data Tree a = Nil | Node a Int (Tree a) (Tree a) deriving (Eq,Ord,Show)
type Multiset a = Tree a
data ThreeValuedBool = TT | FF | Invalid deriving (Eq,Show)
data Order = Up | Down deriving (Eq,Show)

--Beispiel 1
--Ein Baum t ist ein Multiset, wenn t Suchbaum 
--und der Zahlenwert an jedem Knoten groesser gleich 0
isMultiset :: Ord a => Tree a -> Bool
isMultiset Nil = True 
isMultiset t = isMultiset' t where
	isMultiset' Nil = False
	isMultiset' (Node v i l r)
	 | (isNodeTree l) && (isNodeTree r) = (allsmaller l v) && (isMultiset' l) && (allgreater r v) && (isMultiset' r) && (i >= 0)
	 | isNodeTree l = (allsmaller l v) && (isMultiset' l) && (i >= 0)
	 | isNodeTree r = (allgreater r v) && (isMultiset' r) && (i >= 0)
	 | otherwise = i >= 0

--isNodeTree überprüft, ob übergebener Baum nichtleer
isNodeTree :: Tree a -> Bool
isNodeTree Nil = False
isNodeTree _ = True

--allsmaller überprüft, ob alle Werte im Baum kleiner als der übergebene Wert
allsmaller :: Ord a => Tree a -> a-> Bool
allsmaller Nil _ = True
allsmaller (Node w _ l r) v = (v > w)  && (allsmaller l v) && (allsmaller r v) 

--allgreater überprüft, ob alle Werte im Baum größer als der übergebene Wert
allgreater :: Ord a => Tree a -> a -> Bool
allgreater Nil _ = True
allgreater (Node w _ l r) v = (w > v) && (allgreater l v) && (allgreater r v)

--Beispiel 2
--Ein Baum t ist ein kanonisches Multiset, wenn t Multiset
--und der Zahlenwert an jedem Knoten echt größer 0
isCanonicalMultiset :: Ord a => Tree a -> Bool
isCanonicalMultiset Nil = True
isCanonicalMultiset t = isMultiset t && greaterZero t where
	greaterZero Nil = True
	greaterZero (Node _ i l r)
	 | (isNodeTree l) && (isNodeTree r) = (i > 0) && (greaterZero l) && (greaterZero r)
	 | isNodeTree l = (i > 0) && (greaterZero l)
	 | isNodeTree r = (i > 0) && (greaterZero r)
	 | otherwise = i > 0

--Beipiel 3
--mkMultiset nimmt einen Baum, der kein Suchbaum sein muss, als Argument
--und gibt ein Multiset zurück
mkMultiset :: (Ord a,Show a) => Tree a -> Multiset a
mkMultiset Nil = Nil
mkMultiset t = foldl add Nil $ map (giveValue t) $ (removeDouble.allElems) t 

allElems :: Tree a -> [a]
allElems Nil = []
allElems (Node v _ l r)
	 | (isNodeTree l) && (isNodeTree r) = [v] ++ (allElems l) ++ (allElems r)
	 | isNodeTree l = [v] ++ (allElems l)
	 | isNodeTree r = [v] ++ (allElems r)
	 | otherwise = [v]

removeDouble :: Ord a => [a] -> [a]
removeDouble [] = []
removeDouble (x:xs)
 | elem x xs = removeDouble xs
 | otherwise = x:(removeDouble xs)

giveValue :: Ord a => Tree a -> a -> (a,Int)
giveValue Nil x = (x,0)
giveValue (Node v i l r) x
 | v == x = (x, (sumNodeVals (Node v i l r) x))
 | otherwise = sum (giveValue l x) (giveValue r x) where
 	sum (a,b) (c,d) = (a,(b+d))

sumNodeVals :: Ord a => Tree a -> a -> Int
sumNodeVals Nil e = 0
sumNodeVals (Node v i l r) e
 | (isNodeTree l) && (isNodeTree r) && (v == e) = i + (sumNodeVals l e) + (sumNodeVals r e)
 | (isNodeTree l) && (v == e) = i + (sumNodeVals l e)
 | (isNodeTree r) && (v == e) = i + (sumNodeVals r e)
 | (v == e) = i
 | otherwise = 0

add :: Ord a => Tree a -> (a,Int) -> Tree a
add Nil (x,y) = (Node x (max 0 y) Nil Nil)
add (Node v i l r) (x,y)
 | v == x = (Node v i l r)
 | x < v = (Node v i (add l (x,y)) r)
 | otherwise = (Node v i l (add r (x,y)))

--Beispiel 4 
--mkCanonicalMultiset nimmt einen Baum, der kein Suchbaum sein muss, als Argument
--und gibt ein kanonisches Multiset zurück
mkCanonicalMultiset :: (Ord a,Show a) => Tree a -> Multiset a
mkCanonicalMultiset Nil = Nil
mkCanonicalMultiset t = foldl add Nil $ removeZeros $ map (giveValue t) $ (removeDouble.allElems) t

removeZeros :: Ord a => [(a,Int)] -> [(a,Int)]
removeZeros [] = []
removeZeros (x:xs)
 | (snd x) <= 0 = removeZeros xs
 | otherwise = x : (removeZeros xs)

--Beispiel 5
--Liefert bei Multimenge m aufsteigende(absteigende) Tupelliste, wenn Vorkommen größer 0
flatten :: (Ord a,Show a) => Order -> Multiset a -> [(a,Int)]
flatten o m
 | (isMultiset m) == False = []
 | o == Up = flattenUp m
 | otherwise = reverse.flattenUp $ m

flattenUp :: (Ord a,Show a) => Multiset a -> [(a,Int)]
flattenUp Nil = []
flattenUp (Node v i l r)
 | i > 0 = (flattenUp l) ++ [(v,i)] ++ (flattenUp r)
 | otherwise = (flattenUp l) ++ (flattenUp r)

--Beispiel 6
--Liefert die Anzahl der Vorkommen von a A in Multimenge m
--Ist m keine Multimenge, wird -1 zurückgegeben
isElement :: Ord a => a -> Multiset a -> Int
isElement e Nil = 0
isElement e (Node v i l r) 
 | isMultiset (Node v i l r) == False = -1
 | (e == v) = i
 | (e < v) = isElement e l
 | otherwise = isElement e r

--Beispiel 7
--isSubset gibt TT zurück, wenn m1 eine Teilmenge von m2 ist 
--es ist egal, ob m1,m2 kanonisch sind
--ist m1 oder m2 keine Multimenge, wird Invalid zurückgegeben
isSubset :: Ord a => Multiset a -> Multiset a -> ThreeValuedBool
isSubset m1 m2
 | (isMultiset m1 == False) || (isMultiset m2 == False) = Invalid
 | otherwise = threeValue $ subsetTest m1 m2 where 
        threeValue True = TT
 	threeValue _ = FF 
 	subsetTest Nil Nil = True
        subsetTest Nil (Node v i l r) = True
        subsetTest (Node v i l r) Nil = False 
        subsetTest (Node v1 i1 l1 r1) (Node v2 i2 l2 r2) = (i1 <= (isElement v1 m2)) && (subsetTest l1 m2) && (subsetTest r1 m2)

--Beispiel 8
--angewendet auf zwei Multimengen m1 und m2 liefert die Funktion join eine kanonische 
--Multimenge m3, die die Vereinigung von m1 und m2 darstellt.
--Ist eines der Argutmente keine Multimenge, wird Nil zurückgegeben
join :: (Ord a,Show a) => Multiset a -> Multiset a -> Multiset a
join m1 m2
 | ((isMultiset m1) == False) || ((isMultiset m2) == False) = Nil
 | (isNodeTree m1) && (m2 == Nil) = mkCanonicalMultiset m1
 | (m1 == Nil) && (isNodeTree m2) = mkCanonicalMultiset m2
 | otherwise = mkCanonicalMultiset $ foldl join' Nil $ (flattenUp m1) ++ (flattenUp m2) where
 	join' Nil (x,y) = (Node x y Nil Nil)
 	join' (Node v i l r) (x,y)
 	 | v == x = (Node v (i+y) l r)
 	 | x < v = (Node v i (join' l (x,y)) r)
 	 | otherwise = (Node v i l (join' r (x,y)))

--Beispiel 9
--angewendet auf zwei Multimengen m1 und m2 gibt meet die kanonische Darstellung m3 des 
--Durchschnitts von m1 und m2
--Ist eines dieser Argumente keine Multimege, liefert die Funktion den Wert Nil
meet :: (Ord a,Show a) => Multiset a -> Multiset a -> Multiset a
meet m1 m2
 | ((isMultiset m1) == False) || ((isMultiset m2) == False) = Nil
 | (isNodeTree m1 == False) || (isNodeTree m2 == False) = Nil
 | otherwise = mkCanonicalMultiset $ foldl add Nil $ meet' (flattenUp m1) m2 where
 	meet' [] _ = []
 	meet' l Nil = []
 	meet' (x:xs) t
 	 | (isElement (fst x) t) > 0 = ((fst x), (min (snd x) (isElement (fst x) t))): (meet' xs t)
 	 | otherwise = meet' xs t

--Beispiel 10
--angewendet auf zwei Multimengen m1, m2 gibt subtract die kanonische Darstellung m3 der 
--Differenz von m1 und m2. m3 enthält jeden in m1 vorkommenden a-Wert so oft, wie er in m1
--vorkommt abzüglich der Zahl der Vorkommen dieses Werts in m2
--Ist eines der Argumente keine Multimenge, liefert die Funktion den Wert Nil
subtract :: (Ord a,Show a) => Multiset a -> Multiset a -> Multiset a
subtract m1 m2
 | ((isMultiset m1) == False) || ((isMultiset m2) == False) = Nil
 | (isNodeTree m2 == False) = mkCanonicalMultiset m1
 | (isNodeTree m1 == False) = Nil
 | otherwise = mkCanonicalMultiset $ foldl add Nil $ subtract' (flattenUp m1) m2 where
 	subtract' [] _ = []
 	subtract' l Nil = l
 	subtract' (x:xs) t
 	 | (isElement (fst x) t) > 0 = ((fst x), ((snd x) - (isElement (fst x) t))): (subtract' xs t)
 	 | otherwise = x : (subtract' xs t)


